package com.gonval.precioselectricidad.activities;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;

import com.gonval.precioselectricidad.beans.ItemPrice;
import com.gonval.precioselectricidad.database.DataBaseHelper;
import com.gonval.precioselectricidad.database.DataBaseManager;
import com.gonval.precioselectricidad.database.PricesDAO;
import com.gonval.precioselectricidad.util.UtilTime;

public class AlarmReceiver extends BroadcastReceiver {

	private HttpTask httpTask;
	public static int BD_VERSION = 1;

	@Override
	public void onReceive(Context context, Intent intent) {

		DataBaseHelper database = new DataBaseHelper(context, BD_VERSION);
		DataBaseManager.initializeInstance(database);
		PricesDAO dao = new PricesDAO();
		Date day = UtilTime.getTomorrow();
		Date today = UtilTime.getToday();
		SimpleDateFormat df = new SimpleDateFormat("dd/MM/yyyy");
		SimpleDateFormat dayFormat = new SimpleDateFormat("dd");
		String dayStr = df.format(day);
		boolean firstDayMonth = false;

		ArrayList<ItemPrice> listaprecios = dao.getPricesDay(dayStr);
		if (listaprecios.size() > 0) {
			UtilTime.cancelAlarm(context);
			UtilTime.setAlarmTomorrow(context);
		} else {
			if (dayFormat.format(today).equals("1")) {
				dao.deletePrices();
				firstDayMonth = true;
			}
			httpTask = new HttpTask(false, context, firstDayMonth);
			httpTask.execute();
		}
	}
}