package com.gonval.precioselectricidad.activities;

import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup;
import android.widget.ToggleButton;

import com.gonval.precioselectricidad.R;
import com.gonval.precioselectricidad.database.DataBaseHelper;
import com.gonval.precioselectricidad.database.DataBaseManager;

public class ConfigurationFragment extends Fragment {

	public static int BD_VERSION = 1;
	private ToggleButton tb = null;
	private DataBaseHelper dbService= null;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setHasOptionsMenu(true);
	}

	@Override
	public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
		
		View view =  inflater.inflate(R.layout.activity_configuration, container, false);
		dbService  = new DataBaseHelper(getActivity(), BD_VERSION);
		
		DataBaseManager.initializeInstance(dbService);
			
		tb = (ToggleButton) view.findViewById(R.id.toggleButtonNoti);
		int status = dbService.getNotificationStatus();
		
		if(status == 1){
			tb.setChecked(true);
		}
		tb.setOnClickListener(new OnClickListener() {
			
			@Override
			public void onClick(View v) {
				if (tb.isChecked()){
					dbService.setNotificationStatus(1);
				} else {
					dbService.setNotificationStatus(0);
				}
			}
		});
		return view;
	}

	@Override
	public void onActivityCreated(Bundle savedInstanceState) {
		super.onActivityCreated(savedInstanceState);
	}

	@Override
	public void onResume() {
		super.onResume();
	}
}
