package com.gonval.precioselectricidad.activities;

import java.io.File;

import android.app.NotificationManager;
import android.content.Intent;
import android.content.res.Configuration;
import android.os.Bundle;
import android.support.v4.app.ActivityCompat;
import android.support.v4.app.Fragment;
import android.support.v4.app.FragmentManager;
import android.support.v4.widget.DrawerLayout;
import android.view.MenuItem;
import android.view.View;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.support.v7.app.ActionBarActivity;
import android.support.v7.app.ActionBarDrawerToggle;
import android.support.v7.widget.Toolbar;

import com.gonval.precioselectricidad.R;

public class MainActivity extends ActionBarActivity {

	private String[] optionsMenu;
	private ListView navList;
	private CharSequence tituloSeccion;
	private CharSequence tituloApp;
	private DrawerLayout drawerLayout;
	private ActionBarDrawerToggle drawerToggle;
	public int id = 0;
	public static int BD_VERSION = 1;
	private Bundle extras = null;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_main);
		
		/**inicializar el menu de navegacion**/
		optionsMenu = getResources().getStringArray(R.array.nav_options);
		ArrayAdapter<String> adapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, optionsMenu);
		navList = (ListView) findViewById(R.id.left_drawer);
		navList.setAdapter(adapter);
		/**fin**/
		
		File database = getApplicationContext().getDatabasePath("pricesElectricityDataBase");
		if(!database.exists()){
			HttpTask httptask = new HttpTask(true, this, this);
			httptask.execute();
			Intent intent = getIntent();
			extras = intent.getExtras();

		}else{
			Intent intent = getIntent();
			extras = intent.getExtras();
			loadFragment();
		}
		
		drawerLayout = (DrawerLayout) findViewById(R.id.drawer_layout);
		navList.setOnItemClickListener(new OnItemClickListener() {

			@Override
			public void onItemClick(AdapterView parent, View view, int position, long id) {

				Fragment fragment = null;
				int num=5;
				switch (position) {
				case 0:
					fragment = new PricesListFragment();
					num = 0;
					break;
				case 1:
					fragment = new PricesListFragment();
					num = 1;
					break;
				case 2:
					fragment = new PricesListFragment();
					num = 2;
					break;
				case 3:
					fragment = new ConfigurationFragment();
					break;
				}
				
				FragmentManager fragmentManager = getSupportFragmentManager();
				Bundle args = new Bundle(); 
				args.putInt("num", num); 
				fragment.setArguments(args); 
				fragmentManager.beginTransaction().replace(R.id.content_frame, fragment).commit();

				navList.setItemChecked(position, true);
				tituloSeccion = optionsMenu[position];
				getSupportActionBar().setTitle(tituloSeccion);
				drawerLayout.closeDrawer(navList);
			}
		});
		tituloSeccion = getTitle();
		tituloApp = getTitle();

		drawerToggle = new ActionBarDrawerToggle(this, drawerLayout, new Toolbar(MainActivity.this), R.string.drawer_open, R.string.drawer_close) {

			public void onDrawerClosed(View view) {

				getSupportActionBar().setTitle(tituloSeccion);
				ActivityCompat.invalidateOptionsMenu(MainActivity.this);
			}

			public void onDrawerOpened(View drawerView) {
				getSupportActionBar().setTitle(tituloApp);
				ActivityCompat.invalidateOptionsMenu(MainActivity.this);
			}
		};
		drawerLayout.setDrawerListener(drawerToggle);
		getSupportActionBar().setDisplayHomeAsUpEnabled(true);
		getSupportActionBar().setHomeButtonEnabled(true);
	}
	
	@Override
	protected void onResume() {
		super.onResume();
	}
	
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		if (drawerToggle.onOptionsItemSelected(item)) {
			return true;
		}
		return super.onOptionsItemSelected(item);
	}

	@Override
	protected void onPostCreate(Bundle savedInstanceState) {
		super.onPostCreate(savedInstanceState);
		drawerToggle.syncState();
	}

	@Override
	public void onConfigurationChanged(Configuration newConfig) {
		super.onConfigurationChanged(newConfig);
		drawerToggle.onConfigurationChanged(newConfig);
	}
	public void loadFragment(){

		NotificationManager nm = (NotificationManager) getSystemService(NOTIFICATION_SERVICE);
		Fragment fragment = null;
		fragment = new PricesListFragment();
		FragmentManager fragmentManager = getSupportFragmentManager();
		fragmentManager.beginTransaction().replace(R.id.content_frame, fragment).commit();
		
		if (extras != null) {
			if (extras.containsKey("notificationID")) {
				Bundle args = new Bundle(); 
				args.putInt("num", 1); 
				fragment.setArguments(args);
				tituloSeccion = optionsMenu[1];
				nm.cancel(getIntent().getExtras().getInt("notificationID"));
			}
		}else{
			Bundle args = new Bundle(); 
			args.putInt("num", 0); 
			fragment.setArguments(args);
			tituloSeccion = optionsMenu[0];
			fragmentManager.beginTransaction().replace(R.id.content_frame, fragment).commit();
		}

		getSupportActionBar().setTitle(tituloSeccion);
	}
}
