package com.gonval.precioselectricidad.adapters;

import java.util.List;

import android.app.Activity;
import android.content.Context;
import android.graphics.Color;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import com.gonval.precioselectricidad.R;
import com.gonval.precioselectricidad.beans.ItemPrice;

public class PricesListViewAdapter extends ArrayAdapter<ItemPrice> {

	Context context;

	public PricesListViewAdapter(Context context, int resourceId, List<ItemPrice> items) {
		super(context, resourceId, items);
		this.context = context;
	}

	private class ViewHolder {

		TextView txtTime;
		TextView txtHours;
	}

	public View getView(int position, View convertView, ViewGroup parent) {

		ViewHolder holder = null;
		ItemPrice rowItem = getItem(position);

		LayoutInflater mInflater = (LayoutInflater) context.getSystemService(Activity.LAYOUT_INFLATER_SERVICE);
		
		if (convertView == null) {
			convertView = mInflater.inflate(R.layout.content, null);
			holder = new ViewHolder();
			holder.txtTime = (TextView) convertView.findViewById(R.id.timetv);
			holder.txtHours = (TextView) convertView.findViewById(R.id.pricetv);
			convertView.setTag(holder);

		} else
			holder = (ViewHolder) convertView.getTag();

		holder.txtTime.setText(rowItem.getTime());
		holder.txtHours.setText(rowItem.getPrice());
		
		if(rowItem.getMax()==1)
			convertView.setBackgroundColor(0xFFF77979);
		else if(rowItem.getMin()==1)
			convertView.setBackgroundColor(0xFFB5FFB5);
		else
			convertView.setBackgroundColor(Color.WHITE);
		return convertView;
	}
}