package com.gonval.precioselectricidad.database;

import android.content.Context;
import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
 
public class DataBaseHelper extends SQLiteOpenHelper {

	private static final String DATABASE_NAME = "pricesElectricityDataBase";
	private static final String TABLE_PRICES = "prices";
	private static final String TABLE_NOTIFICATIONS = "notifications";
    
    // PRICE
    public static String PRICES_COLUMN_DATE = "date";
    public static String PRICES_COLUMN_TIME = "time";
    public static String PRICES_COLUMN_PRICE = "price";
    
    //NOTIFICATIONS
    public static String NOTIFICATIONS_COLUMN_STATUS = "status";
    
    private static final String CREATE_TABLE_PRICES
    		= "CREATE TABLE " + TABLE_PRICES + "(" 
    		+ PRICES_COLUMN_DATE + " DATE,"
    		+ PRICES_COLUMN_TIME + " TEXT,"
    	    + PRICES_COLUMN_PRICE + " TEXT);";
    
    private static final String CREATE_TABLE_NOTIFICATIONS
    		="CREATE TABLE " + TABLE_NOTIFICATIONS + "("
    		+ NOTIFICATIONS_COLUMN_STATUS + " INT DEFAULT 1);";

    public DataBaseHelper(Context context, int version) {
        super(context, DATABASE_NAME, null, version);
    }
 
    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL(CREATE_TABLE_PRICES);
        db.execSQL(CREATE_TABLE_NOTIFICATIONS);
        db.execSQL("INSERT INTO " + TABLE_NOTIFICATIONS +" (" + NOTIFICATIONS_COLUMN_STATUS + ") VALUES (1) ");
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        db.execSQL("delete table if exists " + TABLE_PRICES);
        onCreate(db);
    }
    public void setNotificationStatus(int value){

    	SQLiteDatabase db = DataBaseManager.getInstance().openDatabase();
    	db.execSQL("UPDATE " + TABLE_NOTIFICATIONS + " SET " + NOTIFICATIONS_COLUMN_STATUS + " = '" + value + "'");
    	DataBaseManager.getInstance().closeDatabase();
    }
    public int getNotificationStatus(){
    	
    	int result = 2;
    	SQLiteDatabase db = DataBaseManager.getInstance().openDatabase();
    	Cursor cursor = db.rawQuery("SELECT * FROM " + TABLE_NOTIFICATIONS, null);
        if(cursor != null && cursor.moveToFirst()){
        	result =  cursor.getInt(0);
        }
    	DataBaseManager.getInstance().closeDatabase();
    	cursor.close();
		return result;
    }
 }
    