package com.gonval.precioselectricidad.database;

import java.util.ArrayList;
import java.util.Iterator;

import android.database.Cursor;
import android.database.sqlite.SQLiteDatabase;

import com.gonval.precioselectricidad.beans.ItemPrice;

public class PricesDAO {
	
	private static final String TABLE_PRICES = "prices";
	
    public static String PRICES_COLUMN_DATE = "date";
    public static String PRICES_COLUMN_TIME = "time";
    public static String PRICES_COLUMN_PRICE = "price";

    public ArrayList<ItemPrice> getPricesDay(String date){
    	
    	SQLiteDatabase db = DataBaseManager.getInstance().openDatabase();
    	ArrayList<ItemPrice> dataList = new ArrayList<ItemPrice>();
    	String sql = "SELECT " +
        		 	PRICES_COLUMN_DATE + ", " +
        		 	PRICES_COLUMN_TIME + ", " +
        		 	PRICES_COLUMN_PRICE +
        		 	" FROM " + TABLE_PRICES;
    	if(date !=""){
    		sql+=  " WHERE " + PRICES_COLUMN_DATE + "= '" + date + "'"; 
    	}else{
    		sql+= " order by " + PRICES_COLUMN_DATE + " desc, " + PRICES_COLUMN_TIME;
    	}
        Cursor cursor = db.rawQuery(sql, null);
        if(cursor != null && cursor.moveToFirst()){
        	do{
        		ItemPrice data =  new ItemPrice();
             	data.setDate(cursor.getString(0));
            	data.setTime(cursor.getString(1));
            	data.setPrice(cursor.getString(2));
            	dataList.add(data);
        	} while(cursor.moveToNext());
        }
        cursor.close();
        DataBaseManager.getInstance().closeDatabase();
        return dataList;
    }
    public void deletePrices(){
    	SQLiteDatabase db = DataBaseManager.getInstance().openDatabase();
    	db.execSQL("DELETE from " + TABLE_PRICES);
    	DataBaseManager.getInstance().closeDatabase();
    }
    public ArrayList<ItemPrice> getMaxPricesDay(String date){
    	
    	SQLiteDatabase db = DataBaseManager.getInstance().openDatabase();
    	ArrayList<ItemPrice> dataList = new ArrayList<ItemPrice>();
    	String sql = "SELECT '1' as max, " + PRICES_COLUMN_TIME +
        		 	 " FROM ( SELECT * FROM " + TABLE_PRICES + " WHERE " + PRICES_COLUMN_DATE + " = '" + date + 
    				 "' order by cast(" + PRICES_COLUMN_PRICE + " as double) desc limit 5) UNION " +  
    				 "SELECT '0' as max, " + PRICES_COLUMN_TIME +
        		 	 " FROM ( SELECT * FROM " + TABLE_PRICES + " WHERE " + PRICES_COLUMN_DATE + " = '" + date + 
    				 "' order by cast(" + PRICES_COLUMN_PRICE + " as double) asc limit 19) order by " + PRICES_COLUMN_TIME;
       
    	 Cursor cursor = db.rawQuery(sql, null);
         if(cursor != null && cursor.moveToFirst()){
         	do{
         		ItemPrice data =  new ItemPrice();
         		data.setTime(cursor.getString(1));
             	data.setMax(cursor.getInt(0));
             	dataList.add(data);
         	} while(cursor.moveToNext());
         }
         cursor.close();
         DataBaseManager.getInstance().closeDatabase();
         return dataList;
    }
    public ArrayList<ItemPrice> getMinPricesDay(String date){
    	
    	SQLiteDatabase db = DataBaseManager.getInstance().openDatabase();
    	ArrayList<ItemPrice> dataList = new ArrayList<ItemPrice>();
    	String sql = "SELECT '1' as min, " + PRICES_COLUMN_TIME +
        		 	 " FROM ( SELECT * FROM " + TABLE_PRICES + " WHERE " + PRICES_COLUMN_DATE + " = '" + date + 
    				 "' order by cast(" + PRICES_COLUMN_PRICE + " as double) asc limit 5) UNION " +  
    				 "SELECT '0' as min, " + PRICES_COLUMN_TIME +
        		 	 " FROM ( SELECT * FROM " + TABLE_PRICES + " WHERE " + PRICES_COLUMN_DATE + " = '" + date + 
    				 "' order by cast(" + PRICES_COLUMN_PRICE + " as double) desc limit 19) order by " + PRICES_COLUMN_TIME;
       
    	 Cursor cursor = db.rawQuery(sql, null);
         if(cursor != null && cursor.moveToFirst()){
         	do{
         		ItemPrice data =  new ItemPrice();
         		data.setTime(cursor.getString(1));
             	data.setMin(cursor.getInt(0));
             	dataList.add(data);
         	} while(cursor.moveToNext());
         }
         cursor.close();
         DataBaseManager.getInstance().closeDatabase();
         return dataList;
    }
    public int checkValuesDay(String date) {
    	
    	SQLiteDatabase db = DataBaseManager.getInstance().openDatabase();
    	String sql = 
    			"SELECT * " +
    		 	" FROM " + TABLE_PRICES +
    			" WHERE " + PRICES_COLUMN_DATE + "= '" + date + "'"; 

    	Cursor cursor = db.rawQuery(sql, null);
    	int rows = cursor.getCount();
    	cursor.close();
    	DataBaseManager.getInstance().closeDatabase();
    	return rows;
    	
	}
    public void insertListDay(ArrayList<ItemPrice> precios){
    	
    	SQLiteDatabase db = DataBaseManager.getInstance().openDatabase();
  	  	Iterator it = precios.iterator();
  	  	while(it.hasNext()){
  	  	ItemPrice data = (ItemPrice) it.next();
  	  		db.execSQL("INSERT INTO " + TABLE_PRICES +
      		   " VALUES ('" +
      		   data.getDate() + "', '" +
      		   data.getTime() + "', '" +
    		   data.getPrice() + "');");
  	  	
  	  	}
  	  	DataBaseManager.getInstance().closeDatabase();
    }
}
