package com.gonval.precioselectricidad.util;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.HttpURLConnection;
import java.net.URL;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import android.content.Context;
import au.com.bytecode.opencsv.CSVReader;

import com.gonval.precioselectricidad.beans.ItemPrice;
import com.gonval.precioselectricidad.database.DataBaseHelper;
import com.gonval.precioselectricidad.database.DataBaseManager;
import com.gonval.precioselectricidad.database.PricesDAO;

public class Csvreader
{

	private static final int HOUR = 3;
	private static final int PRICE2 = 5;

	private static String base_url;
	public static int BD_VERSION = 1;
	
	public Boolean getPricesFromWeb(Context context, Date date)
	{
		DataBaseHelper dbService = new DataBaseHelper(context, BD_VERSION);
		DataBaseManager.initializeInstance(dbService);
		PricesDAO dao = new PricesDAO();
		base_url = "http://www.omie.es/datosPub/marginalpdbc/marginalpdbc_";
		InputStream input = null;
		HttpURLConnection connection = null;
		String dateFormatDB = "";
		String dateFormatWeb = "";
		String[] line;
		List<String[]> data = new ArrayList<String[]>();
		ArrayList<ItemPrice> precios = new ArrayList<ItemPrice>();
		Boolean success;

		try
		{
			SimpleDateFormat df = new SimpleDateFormat("dd/MM/yyyy");
			SimpleDateFormat df2 = new SimpleDateFormat("yyyyMMdd");
			
			dateFormatDB = df.format(date);
			dateFormatWeb = df2.format(date);

			base_url += dateFormatWeb + ".1";

			URL url = new URL(base_url);
			connection = (HttpURLConnection) url.openConnection();
			connection.connect();

			// expect HTTP 200 OK, so we don't mistakenly save error report
			// instead of the file
			if (connection.getResponseCode() != HttpURLConnection.HTTP_OK)
			{
				success= false;
				return success;
			}

			// download the file
			input = connection.getInputStream();
			InputStreamReader csvStreamReader = new InputStreamReader(input);
			CSVReader csvReader = new CSVReader(csvStreamReader, ';');

			// throw away the header
			csvReader.readNext();

			while ((line = csvReader.readNext()) != null)
			{
				if(!line[0].equals("*"))
					data.add(line);
			}
			csvReader.close();
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
		// Save result
		String URL = connection.getURL().getProtocol() + "://"+ connection.getURL().getHost() + connection.getURL().getPath();
		if(URL.equalsIgnoreCase(base_url)){
			for(int i = 0; i < data.size(); i++){
				line = data.get(i);
				ItemPrice dataToSave = new ItemPrice();
				if(line[HOUR].length() == 1)
					dataToSave.setTime("0"+ line[HOUR]+":00");
				else
					dataToSave.setTime(line[HOUR]+":00");
				dataToSave.setPrice(line[PRICE2]);
				dataToSave.setDate(dateFormatDB);
				precios.add(dataToSave);
			}
			if(precios.size()==24){
				dao.insertListDay(precios);
				success = true;
			}else{
				success = false;
			}
		}else{
			success = false;
		}
		return success;
	}
}
