package com.gonval.precioselectricidad.util;

import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import android.app.AlarmManager;
import android.app.PendingIntent;
import android.content.Context;
import android.content.Intent;

import com.gonval.precioselectricidad.activities.AlarmReceiver;

public class UtilTime {
	
	private static AlarmManager alarmMgr;
	private static PendingIntent pendingIntent;
	private final static int HOUR = 12;
	private final static int MINUTE = 00;
	
	public static Date getToday(){
		
		Calendar cal = Calendar.getInstance();
		Date date = cal.getTime(); 
		return date;
	}
	
	public static Date getTomorrow(){
		
		Calendar cal = Calendar.getInstance();
		cal.add(Calendar.DATE, 1);
		Date date = cal.getTime(); 
		return date;
		
	}
	public static String getHour(){
		
		SimpleDateFormat df = new SimpleDateFormat("HH");
		Calendar cal = Calendar.getInstance();
		Date date = cal.getTime(); 
		String hour = df.format(date);
		
		return hour;
	}
	
	public static void setAlarm(Context context){
		
		alarmMgr = (AlarmManager)context.getSystemService(Context.ALARM_SERVICE);
		Intent intentAlarm = new Intent(context, AlarmReceiver.class);
		pendingIntent = PendingIntent.getBroadcast(context, 0, intentAlarm, 0);

		Calendar calendar = Calendar.getInstance();
		calendar.setTimeInMillis(System.currentTimeMillis());
		calendar.set(Calendar.HOUR_OF_DAY, HOUR);
		calendar.set(Calendar.MINUTE, MINUTE);

		alarmMgr.setRepeating(AlarmManager.RTC_WAKEUP, calendar.getTimeInMillis(), 1000 * 60 * 15, pendingIntent);
	}
	public static void setAlarmTomorrow(Context context){
		
		alarmMgr = (AlarmManager)context.getSystemService(Context.ALARM_SERVICE);
		Intent intentAlarm = new Intent(context, AlarmReceiver.class);
		pendingIntent = PendingIntent.getBroadcast(context, 0, intentAlarm, 0);

		Calendar calendar = Calendar.getInstance();
		calendar.setTimeInMillis(System.currentTimeMillis());
		calendar.set(Calendar.HOUR_OF_DAY, HOUR);
		calendar.set(Calendar.MINUTE, MINUTE);
		calendar.roll(Calendar.DAY_OF_YEAR, 1);

		alarmMgr.setRepeating(AlarmManager.RTC_WAKEUP, calendar.getTimeInMillis(), 1000 * 60 * 15, pendingIntent);
	}
	public static void cancelAlarm(Context context){
		
		alarmMgr = (AlarmManager)context.getSystemService(Context.ALARM_SERVICE);
		Intent intentAlarm = new Intent(context, AlarmReceiver.class);
		pendingIntent = PendingIntent.getBroadcast(context, 0, intentAlarm, 0);
		
		alarmMgr.cancel(pendingIntent);
	}
}
